+ # Validate PATHOUT_TAR as tar.
+ checkMakeTar "$PATHOUT_TAR";
+ ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+ if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
+
+ # Write bufferBash to PATHOUT_TAR
+ appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_NMEA" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_NMEA" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write NMEA data
+ appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_GPX" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_GPX" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write GPX file
+ appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_KML" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_KML" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write KML file
+
+ # Remove secured chunks from DIR_TMP
+ rm "$PATHOUT_BUFFER" "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
+ vbm "DEBUG:STATUS:$FN:Finished magicWriteBuffer().";
+} # write buffer to disk
+magicParseRecipientDir() {
+ # Desc: Updates recPubKeysValid with pubkeys in dir specified by '-R' option ("recipient directory")
+ # Inputs: vars: OPTION_RECDIR, argRecDir, OPTION_ENCRYPTION
+ # arry: recPubKeysValid
+ # Outputs: arry: recPubKeysValid
+ # Depends: processArguments,
+ local recFileLine updateRecipients recipientDir
+ declare -a candRecPubKeysValid
+
+ # Check that '-e' and '-R' set
+ if [[ "$OPTION_ENCRYPTION" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
+ ### Check that argRecDir is a directory.
+ if [[ -d "$argRecDir" ]]; then
+ recipientDir="$argRecDir";
+ #### Initialize variable indicating outcome of pubkey review
+ unset updateRecipients
+ #### Add existing recipients
+ candRecPubKeysValid=("${recPubKeysValid[@]}");
+ #### Parse files in recipientDir
+ for file in "$recipientDir"/*; do
+ ##### Read first line of each file
+ recFileLine="$(head -n1 "$file")";
+ ##### check if first line is a valid pubkey
+ if checkAgePubkey "$recFileLine" && \
+ ( validateInput "$recFileLine" "ssh_pubkey" || validateInput "$recFileLine" "age_pubkey"); then
+ ###### T: add candidate pubkey to candRecPubKeysValid
+ candRecPubKeysValid+=("$recFileLine");
+ else
+ ###### F: throw warning;
+ yell "ERROR:Invalid recipient file detected. Not modifying recipient list."
+ updateRecipients="false";
+ fi;
+ done
+ #### Write updated recPubKeysValid array to recPubKeysValid if no failure detected
+ if ! [[ "$updateRecipients" = "false" ]]; then
+ recPubKeysValid=("${candRecPubKeysValid[@]}");
+ fi;
+ else
+ yell "ERROR:$0:Recipient directory $argRecDir does not exist. Exiting."; exit 1;
+ fi;
+ fi;
+ # Handle case if '-e' set but '-R' not set
+ if [[ "$OPTION_ENCRYPTION" = "true" ]] && [[ ! "$OPTION_RECDIR" = "true" ]]; then
+ yell "ERROR: \\'-e\\' set but \\'-R\\' is not set."; fi;
+ # Handle case if '-R' set but '-e' not set
+ if [[ ! "$OPTION_ENCRYPTION" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
+ yell "ERROR: \\'-R\\' is set but \\'-e\\' is not set."; fi;
+} # Update recPubKeysValid with argRecDir
+magicParseRecipientArgs() {
+ # Desc: Parses recipient arguments specified by '-r' option
+ # Input: vars: OPTION_ENCRYPT from processArguments()
+ # arry: argRecPubKeys from processArguments()
+ # Output: vars: CMD_ENCRYPT, CMD_ENCRYPT_SUFFIX
+ # arry: recPubKeysValid
+ # Depends: checkapp(), checkAgePubkey(), validateInput(), processArguments()
+ local recipients
+
+ # Check if encryption option active.
+ if [[ "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECIPIENTS" = "true" ]]; then
+ if checkapp age; then # Check that age is available.
+ for pubkey in "${argRecPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
+ vbm "DEBUG:Testing pubkey string:$pubkey";
+ if checkAgePubkey "$pubkey" && \
+ ( validateInput "$pubkey" "ssh_pubkey" || validateInput "$pubkey" "age_pubkey"); then
+ #### Form age recipient string
+ recipients="$recipients""-r '$pubkey' ";
+ vbm "STATUS:Added pubkey for forming age recipient string:""$pubkey";
+ vbm "DEBUG:recipients:""$recipients";
+ #### Add validated pubkey to recPubKeysValid array
+ recPubKeysValid+=("$pubkey") && vbm "DEBUG:recPubkeysValid:pubkey added:$pubkey";
+ else
+ yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
+ fi;
+ done
+ vbm "DEBUG:Finished processing argRecPubKeys array";
+
+ ## Form age command string
+ CMD_ENCRYPT="age ""$recipients " && vbm "CMD_ENCRYPT:$CMD_ENCRYPT";
+ CMD_ENCRYPT_SUFFIX=".age" && vbm "CMD_ENCRYPT_SUFFIX:$CMD_ENCRYPT_SUFFIX";
+ else
+ yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
+ fi;
+ else
+ CMD_ENCRYPT="tee /dev/null " && vbm "CMD_ENCRYPT:$CMD_ENCRYPT";
+ CMD_ENCRYPT_SUFFIX="" && vbm "CMD_ENCRYPT_SUFFIX:$CMD_ENCRYPT_SUFFIX";
+ vbm "DEBUG:Encryption not enabled."
+ fi;
+ # Catch case if '-e' is set but '-r' or '-R' is not
+ if [[ "$OPTION_ENCRYPT" = "true" ]] && [[ ! "$OPTION_RECIPIENTS" = "true" ]]; then
+ yell "ERROR:\\'-e\\' set but no \\'-r\\' or \\'-R\\' set."; exit 1; fi;
+ # Catch case if '-r' or '-R' set but '-e' is not
+ if [[ ! "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECIPIENTS" = "true" ]]; then
+ yell "ERROR:\\'-r\\' or \\'-R\\' set but \\'-e\\' is not set."; exit 1; fi;
+} # Populate recPubKeysValid with argRecPubKeys; form encryption cmd string and filename suffix
+magicParseCompressionArg() {
+ # Desc: Parses compression arguments specified by '-c' option
+ # Input: vars: OPTION_COMPRESS
+ # Output: CMD_COMPRESS, CMD_COMPRESS_SUFFIX
+ # Depends: checkapp(), vbm(), gzip,
+ if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
+ if checkapp gzip; then # Check if gzip available
+ CMD_COMPRESS="gzip " && vbm "CMD_COMPRESS:$CMD_COMPRESS";
+ CMD_COMPRESS_SUFFIX=".gz" && vbm "CMD_COMPRESS_SUFFIX:$CMD_COMPRESS_SUFFIX";
+ else
+ yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
+ fi
+ else
+ CMD_COMPRESS="tee /dev/null " && vbm "CMD_COMPRESS:$CMD_COMPRESS";
+ CMD_COMPRESS_SUFFIX="" && vbm "CMD_COMPRESS_SUFFIX:$CMD_COMPRESS_SUFFIX";
+ vbm "DEBUG:Compression not enabled.";
+ fi
+} # Form compression cmd string and filename suffix
+magicInitWorkingDir() {
+ # Desc: Determine temporary working directory from defaults or user input
+ # Usage: magicInitWorkignDir
+ # Input: vars: OPTION_TEMPDIR, argTempDirPriority, DIR_TMP_DEFAULT
+ # Input: vars: SCRIPT_TIME_START
+ # Output: vars: DIR_TMP
+ # Depends: processArguments(), vbm(), yell()
+ # Parse '-t' option (user-specified temporary working dir)
+ ## Set DIR_TMP_PARENT to user-specified value if specified
+ local DIR_TMP_PARENT
+
+ if [[ "$OPTION_TMPDIR" = "true" ]]; then
+ if [[ -d "$argTempDirPriority" ]]; then
+ DIR_TMP_PARENT="$argTempDirPriority";
+ else
+ yell "WARNING:Specified temporary working directory not valid:$argTempDirPriority";
+ exit 1; # Exit since user requires a specific temp dir and it is not available.
+ fi;
+ else
+ ## Set DIR_TMP_PARENT to default or fallback otherwise
+ if [[ -d "$DIR_TMP_DEFAULT" ]]; then
+ DIR_TMP_PARENT="$DIR_TMP_DEFAULT";
+ elif [[ -d /tmp ]]; then
+ yell "WARNING:$DIR_TMP_DEFAULT not available. Falling back to /tmp .";
+ DIR_TMP_PARENT="/tmp";
+ else
+ yell "ERROR:No valid working directory available. Exiting.";
+ exit 1;
+ fi
+ fi;
+ ## Set DIR_TMP using DIR_TMP_PARENT and nonce (SCRIPT_TIME_START)
+ DIR_TMP="$DIR_TMP_PARENT"/"$SCRIPT_TIME_START""..bkgpslog" && vbm "DEBUG:Set DIR_TMP to:$DIR_TMP"; # Note: removed at end of main().
+} # Sets working dir
+magicParseCustomTTL() {
+ # Desc: Set user-specified TTLs for buffer and script
+ # Input: vars: argCustomBufferTTL (integer), argCustomScriptTTL_TE (string)
+ # Input: vars: OPTION_CUSTOM_BUFFERTTL, OPTION_CUSTOM_SCRIPTTTL
+ # Input: vars: BUFFER_TTL (integer), SCRIPT_TTL_TE (string)
+ # Output: BUFFER_TTL (integer), SCRIPT_TTL_TE (string)
+ # Depends validateInput(), showUsage(), yell
+
+ # React to '-b, --buffer-ttl' option
+ if [[ "$OPTION_CUSTOM_BUFFERTTL" = "true" ]]; then
+ ## T: Check if argCustomBufferTTL is an integer
+ if validateInput "$argCustomBufferTTL" "integer"; then
+ ### T: argCustomBufferTTL is an integer
+ BUFFER_TTL="$argCustomBufferTTL";
+ else
+ ### F: argcustomBufferTTL is not an integer
+ yell "ERROR:Invalid integer argument for custom buffer time-to-live."; showUsage; exit 1;
+ fi;
+ ## F: do not change BUFFER_TTL
+ fi;
+
+ # React to '-B, --script-ttl' option
+ if [[ "$OPTION_CUSTOM_SCRIPTTTL_TE" = "true" ]]; then
+ ## T: Check if argCustomScriptTTL is a time element (ex: "day", "hour")
+ if validateInput "$argCustomScriptTTL" "time_element"; then
+ ### T: argCustomScriptTTL is a time element
+ SCRIPT_TTL_TE="$argCustomScriptTTL";
+ else
+ ### F: argcustomScriptTTL is not a time element
+ yell "ERROR:Invalid time element argument for custom script time-to-live."; showUsage; exit 1;
+ fi;
+ ## F: do not change SCRIPT_TTL_TE
+ fi;
+} # Sets custom script or buffer TTL if specified
+
+
+main() {
+ # Process arguments
+ processArguments "$@";
+ ## Act upon arguments
+ ### Determine working directory
+ magicInitWorkingDir; # Sets DIR_TMP from argTempDirPriority
+ ### Set output encryption and compression option strings
+ #### React to "-r" ("encryption recipients") option
+ magicParseRecipientArgs; # Updates recPubKeysValid, CMD_ENCRYPT[_SUFFIX]
+ #### React to "-c" ("compression") option
+ magicParseCompressionArg; # Updates CMD_COMPRESS[_SUFFIX]
+ #### React to "-R" ("recipient directory") option
+ magicParseRecipientDir; # Updates recPubKeysValid
+ #### React to custom buffer and script TTL options ("-b", "-B")
+ magicParseCustomTTL; # Sets custom SCRIPT_TTL_TE and/or BUFFER_TTL if specified
+
+ # Check that critical apps and dirs are available, display missing ones.
+ if ! checkapp gpspipe tar && ! checkdir "$DIR_OUT" "DIR_TMP"; then
+ yell "ERROR:Critical components missing.";
+ displayMissing; yell "Exiting."; exit 1; fi
+
+ # Set script lifespan (SCRIPT_TTL from SCRIPT_TTL_TE)
+ magicSetScriptTTL "$SCRIPT_TTL_TE";
+ ## Note: SCRIPT_TTL_TE is time element string (ex: "day") while SCRIPT_TTL is integer seconds
+
+ # File name substring (ISO-8601 duration from BUFFER_TTL)
+ bufferTTL_STR="$(timeDuration "$BUFFER_TTL")";
+
+ # Init temp working dir
+ try mkdir "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP";
+
+ # Initialize 'tar' archive
+ ## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
+ PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
+ vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
+ ## Check that PATHOUT_TAR is a tar. Rename old and create empty one otherwise.
+ checkMakeTar "$PATHOUT_TAR" && vbm "DEBUG:Confirmed or Created to be a tar:$PATHOUT_TAR";
+ ## Append VERSION file to PATHOUT_TAR
+ magicWriteVersion;
+
+ # Define GPS conversion commands
+ CMD_CONV_NMEA="tee /dev/null " && vbm "STATUS:Set CMD_CONV_NMEA to:$CMD_CONV_NMEA"; # tee as passthrough
+ CMD_CONV_GPX="gpsbabel -i nmea -f - -o gpx -F - " && vbm "STATUS:Set CMD_CONV_GPX to:$CMD_CONV_GPX"; # convert NMEA to GPX
+ CMD_CONV_KML="gpsbabel -i nmea -f - -o kml -F - " && vbm "STATUS:Set CMD_CONV_KML to:$CMD_CONV_KML"; # convert NMEA to KML
+
+ # MAIN LOOP:Record gps data until script lifespan ends
+ while [[ "$SECONDS" -lt "$SCRIPT_TTL" ]]; do
+ magicGatherWriteBuffer &
+ sleep "$BUFFER_TTL";
+ done
+
+ # Cleanup
+ ## Remove DIR_TMP
+ try rm -r "$DIR_TMP";
+
+ vbm "STATUS:Main function finished.";
+} # Main function.
+#===END Declare local script functions===
+#==END Define script parameters==
+
+
+#==BEGIN Perform work and exit==
+main "$@" # Run main function.
+exit 0;
+#==END Perform work and exit==